## specpeptidoms-0.0.1.orig.tar.gz

=== CMakeLists.txt ===
# Author: Olivier Langella
# Created: 06/10/2018

# Global parameters
cmake_minimum_required(VERSION 3.12)
project(specpeptidoms CXX)


SET(SOFTWARE_NAME "specpeptidoms")
SET(SPECPEPTIDOMS_VERSION_MAJOR "0")
SET(SPECPEPTIDOMS_VERSION_MINOR "0")
SET(SPECPEPTIDOMS_VERSION_PATCH "1")
SET(VERSION "${SPECPEPTIDOMS_VERSION_MAJOR}.${SPECPEPTIDOMS_VERSION_MINOR}.${SPECPEPTIDOMS_VERSION_PATCH}")


# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${PROJECT}${ColourReset}\n")

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)
# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
	message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
	add_definitions(-Werror)
endif()

message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(MXE)
	# Run the following cmake command line:
	# x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
	#include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)

	# Set the name to the systemUname variable because in this situation that name
	# is not found, it it passed as a flag in the command line.
	set(systemUname "mxe")

elseif(UNIX AND NOT APPLE)
	# Run the following cmake command line:
	# cmake -DBUILD_USER_MANUAL=1 -DCMAKE_BUILD_TYPE=Debug

	#include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
	include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)

elseif(WIN64)
	# Run the following cmake command line:
	# cmake -DBUILD_USER_MANUAL=0 -DCMAKE_BUILD_TYPE=Release ../development

	include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)

elseif(APPLE)
	# Run the following cmake command line:
	# cmake -DBUILD_USER_MANUAL=0 -DCMAKE_BUILD_TYPE=Release ../development

	include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)
endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${PROJECT}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SystemUname}${ColourReset}")
message("")



#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

# Gee, do not set that to default!
# set(MAKE_TEST 1)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release CACHE STRING
		"Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
		FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
	message(STATUS "Compiling in release mode.")
	add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
	message(STATUS "Compiling in debug mode with MAKE_TEST: ${MAKE_TEST}.")
	message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
	add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
	message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
IF(CMAKE_INSTALL_PREFIX)
  SET(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
ENDIF(CMAKE_INSTALL_PREFIX)


# Subdirectories
#ADD_SUBDIRECTORY(doc)
add_subdirectory(doc)
add_subdirectory(src)

# Packager
SET(CPACK_PACKAGE_NAME "specpeptidoms")
SET(CPACK_PACKAGE_VENDOR "SpecPeptidOms Development Team")
SET(CPACK_PACKAGE_VERSION "${VERSION}")
SET(CPACK_PACKAGE_VERSION_MAJOR "${SPECPEPTIDOMS_VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${SPECPEPTIDOMS_VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${SPECPEPTIDOMS_VERSION_PATCH}")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "SpecPeptidOms")
#SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
#SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
#SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.git"
 ".*\\\\.gz"
 ".*\\\\.deb"
 ".*\\\\.rpm"
 ".*\\\\.dmg"
 ".*\\\\..*\\\\.swp"
 "src/\\\\..*"
 "src/libbpp*"
 "debian/tmp"
 "debian/libbpp.*/"
 "debian/libbpp.*\\\\.so.*"
 "debian/libbpp.*\\\\.a"
 "debian/libbpp.*\\\\.substvars"
 "debian/libbpp.*\\\\.debhelper"
 "debian/debhelper\\\\.log"
 "html"
 "Core.tag"
 "Testing"
 "build/"
 "buildwin64/"
 "build-stamp"
 "install_manifest.txt"
 "DartConfiguration.tcl"
 ${CPACK_SOURCE_IGNORE_FILES}
)



#dch -Dstretch "message"
#cmake ..
#make deb
# scp deepprot* proteus.moulon.inra.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default
# apt-get remove deepprot*
#
#  debuild -S -sa
# dput -f olivier-langella *changes


#dpkg-deb -x libpappsomspp-qt4_0.0.4-1_amd64.deb libpappsomspp-qt4_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt4 -Plibpappsomspp-qt4_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt4.symbols


#dpkg-deb -x libpappsomspp-qt5_0.0.4-1_amd64.deb libpappsomspp-qt5_0.0.4-1
#dpkg-gensymbols -v0 -plibpappsomspp-qt5 -Plibpappsomspp-qt5_0.0.4-1 -Osymbols
#cp symbols ../debian/libpappsomspp-qt5.symbols


SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
INCLUDE(CPack)

IF (UNIX)
#This creates deb packages:


	add_custom_target(targz
		cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz specpeptidoms-${VERSION}.tar.gz
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "Creating .tar.gz" VERBATIM
	)


	add_custom_target(deb
		ln -s specpeptidoms-${VERSION}.tar.gz specpeptidoms-${VERSION}.orig.tar.gz && cd specpeptidoms-${VERSION} && dpkg-buildpackage -B
		DEPENDS targz
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMENT "Creating Debian package" VERBATIM
	)


IF(MAKE_TESTS)
  ENABLE_TESTING()
  INCLUDE(CTest)
  IF (BUILD_TESTING)
    ADD_SUBDIRECTORY(tests)
  ENDIF(BUILD_TESTING)
ENDIF(MAKE_TESTS)

ENDIF(UNIX)

=== doc/CMakeLists.txt ===

set(USETYPST_DEFAULT_ALL_TARGET ON)

message("\n${BoldGreen}Build typst documentation ${PROJECT_NAME}${ColourReset}\n")
include(${CMAKE_UTILS_PATH}/modules/UseTYPST.cmake)
add_typst_document(peptidoms_documentation typst/peptidoms.typ)
add_typst_document(specglobtool_documentation typst/specglobtool.typ)

=== src/CMakeLists.txt ===
# CMake script for peptider
# Author: Olivier Langella
# Created: 28/05/2016

    
# tests : ./src/deepprot -f /gorgone/pappso/moulon/database/Genome_Z_mays_5a.fasta -m /gorgone/pappso/data_extraction_pappso/mzXML/20120906_balliau_extract_1_A01_urnb-1.mzXML
#./src/deepprot -f /espace/Genome_Z_mays_5a.fasta -m /espace/bio/mzxml/20120906_balliau_extract_1_A01_urnb-1.mzXML
# ./src/deepprot -f /gorgone/pappso/moulon/archive_database/Genome_Z_mays_5a.fasta -m /gorgone/pappso/data_extraction_pappso/mzXML/20120906_balliau_extract_1_A01_urnb-1.mzxml -o /gorgone/pappso/versions_logiciels_pappso/deepprot/20181127/test_morpheus.ods


qt6_add_resources(spec_RCC_SRCS "resources.qrc")


configure_file (${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)

# File list
set(CPP_FILES
    output/peptidomscboroutput.cpp
    core/runningpeptidoms.cpp
    core/onescanprocess.cpp
)


set(SPECPEPTIDOMS_CLI_SRCS
    peptidoms.cpp
    ${CPP_FILES}
)
add_executable(peptidoms ${SPECPEPTIDOMS_CLI_SRCS}  )

target_link_libraries(peptidoms
    PappsoMSpp::Core
    Qt6::Core
    Qt6::Widgets
    Qt6::Sql
    Qt6::Qml
    Qt6::Concurrent
    QuaZip::QuaZip
    OdsStream::Core
)

add_executable(proteinmatcher
    proteinmatchercli.cpp
    core/runningproteinmatcher.cpp
    core/onescanprocessproteinmatcher.cpp
    output/peptidomscboroutput.cpp
)

target_link_libraries(proteinmatcher
    PappsoMSpp::Core
    Qt6::Core
    Qt6::Sql
    Qt6::Qml
    Qt6::Concurrent
    QuaZip::QuaZip
    OdsStream::Core
)

add_executable(specglobtool
    specglobtool.cpp
)

target_link_libraries(specglobtool
    PappsoMSpp::Core
    Qt6::Core
    Qt6::Sql
    Qt6::Qml
    Qt6::Concurrent
    QuaZip::QuaZip
    OdsStream::Core
)

add_executable(peptidoms-export peptidomsexport.cpp output/odspsm.cpp  )

target_link_libraries(peptidoms-export
    PappsoMSpp::Core
    Qt6::Core
    Qt6::Widgets
    Qt6::Sql
    Qt6::Qml
    QuaZip::QuaZip
    OdsStream::Core
)

add_executable(psmfeatures psmfeatures.cpp)

target_link_libraries(psmfeatures
    PappsoMSpp::Core
    Qt6::Core
    Qt6::Widgets
    Qt6::Sql
    Qt6::Qml
    QuaZip::QuaZip
    OdsStream::Core
)


add_executable(psmionseries psmionseriescli.cpp)

target_link_libraries(psmionseries
    PappsoMSpp::Core
    Qt6::Core
    Qt6::Widgets
    Qt6::Sql
    Qt6::Qml
    QuaZip::QuaZip
    OdsStream::Core
)

set(PSMFEATURES_CLI_SRCS
    psmfeaturesexport.cpp
    output/odsfeatures.cpp
    ${spec_RCC_SRCS}
)

add_executable(psmfeatures-export ${PSMFEATURES_CLI_SRCS})

target_link_libraries(psmfeatures-export
    PappsoMSpp::Core
    Qt6::Core
    Qt6::Widgets
    Qt6::Sql
    Qt6::Qml
    QuaZip::QuaZip
    OdsStream::Core
)


if (MXE)
    target_compile_options(
        deepprot-gui PRIVATE -mwindows
    )
    set_target_properties(deepprot-gui PROPERTIES LINK_FLAGS "-Wl,--subsystem,windows ${CMAKE_EXE_LINKER_FLAGS}")
endif (MXE)


install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/peptidoms DESTINATION bin)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/peptidoms-export DESTINATION bin)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/proteinmatcher DESTINATION bin)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/specglobtool DESTINATION bin)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/psmionseries DESTINATION bin)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/psmfeatures DESTINATION bin)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/psmfeatures-export DESTINATION bin)

=== tests/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015 from the CMakeLists file of the Bio++ project



find_package(Catch2 REQUIRED)



# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt6Xml_EXECUTABLE_COMPILE_FLAGS}")


configure_file (config.h.cmake ${CMAKE_SOURCE_DIR}/tests/config.h)


# These source files are compiled into a single Catch2-based test binary.
set(tests_cpp_SRCS
  common.cpp
)
# These source files are compiled into a single Catch2-based test binary.
set(catch2_only_cpp_SRCS
    benchmark.cpp
    matrix.cpp
    specglobspectra.cpp
    specglobspeptidepectra.cpp
    test_sgpeptidemodel.cpp
    test_sgposttreatment.cpp
    test_spectralalignment.cpp
  )

add_executable(catch2-only-tests
  ${catch2_only_cpp_SRCS}
  ${tests_cpp_SRCS}
)

add_custom_target(catch2 catch2-only-tests
                  DEPENDS catch2-only-tests
                  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                  COMMENT "Running the Catch2-intbased tests.")

set_property(TARGET catch2 PROPERTY CXX_STANDARD 17) # we want C++17


set(required_target_link_libraries
    PappsoMSpp::Core
    Catch2::Catch2
    Catch2::Catch2WithMain 
    Qt6::Core
    Qt6::Widgets
    Qt6::Sql
    Qt6::Qml
    Boost::chrono
)


target_link_libraries(catch2-only-tests
  ${required_target_link_libraries})

# Add the Catch2-based single binary test file to the CMake's test suite so
# that it gets called using 'make test'. To see the output, add "ARGS=-V" to
# the call.
add_test(catch2-only-tests "catch2-only-tests")

=== debian/changelog ===
specpeptidoms (0.0.1-1~trixie+1) trixie; urgency=medium

  * First package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 12 Dec 2025 11:30:08 +0100

=== debian/control ===
Source: specpeptidoms
Maintainer: Olivier Langella <olivier.langella@u-psud.fr>
Uploaders: Olivier Langella <olivier.langella@u-psud.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
    libpappsomspp-core-dev (>= 0.11.8),
    libpappsomspp-gui-dev (>= 0.11.8),
    libodsstream-dev (>= 0.9.12),
    libboost1.88-dev,
    libboost-thread1.88-dev,
    libboost-chrono1.88-dev,
    libboost-container1.88-dev,
    libboost-random1.88-dev,
    libboost-filesystem1.88-dev,
    libboost-iostreams1.88-dev,
    libzstd-dev,
    liblzf-dev,
    libsqlite3-dev,
    qt6-svg-dev,
    qt6-svg-plugins,
    libqcustomplot-dev (>= 2.1.0),
    cmake,
    catch2
Standards-Version: 4.2.1

Package: specpeptidoms
Architecture: any
Depends: ${shlibs:Depends},
         libpappsomspp-gui0 (>= 0.9.22),
         ${misc:Depends}
Description: MS/MS peptide identification directly on protein sequences
 not requiring tryptic digestion and peptide modeling
 SpecPeptidOMS is based on the work published in
 https://pubs.acs.org/doi/10.1021/acs.jproteome.4c00870.
